<?php
/**
 * @brief		File Storage Extension: Advertisement Images
 *
 * @copyright	(c) 2001 - SVN_YYYY Invision Power Services, Inc.
 *
 * @package		IPS Social Suite
 * @subpackage	Nexus
 * @since		14 Aug 2014
 * @version		SVN_VERSION_NUMBER
 */

namespace IPS\nexus\extensions\core\FileStorage;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * Editor Extension: Advertisement Images
 */
class _Ads
{
	/**
	 * Count stored files
	 *
	 * @return	int
	 */
	public function count()
	{
		return \IPS\Db::i()->select( 'COUNT(*)', 'core_advertisements', array( 'ad_member<>0' ) )->first();
	}
	
	/**
	 * Move stored files
	 *
	 * @param	int			$offset					This will be sent starting with 0, increasing to get all files stored by this extension
	 * @param	int			$storageConfiguration	New storage configuration ID
	 * @param	int|NULL	$oldConfiguration		Old storage configuration ID
	 * @throws	\Underflowexception				When file record doesn't exist. Indicating there are no more files to move
	 * @return	void
	 */
	public function move( $offset, $storageConfiguration, $oldConfiguration=NULL )
	{
		$record = \IPS\Db::i()->select( '*', 'core_advertisements', array( 'ad_member<>0' ), 'ad_id', array( $offset, 1 ) )->first();
		
		$images = json_decode( $record['ad_images'], TRUE );
		foreach ( $images as $key => $location )
		{
			try
			{
				$images[ $key ] = (string) \IPS\File::get( $oldConfiguration ?: 'nexus_Ads', $location )->move( $storageConfiguration );
			}
			catch( \Exception $e )
			{
				/* Any issues are logged */
			}
		}
		\IPS\Db::i()->update( 'core_advertisements', array( 'ad_images' => json_encode( $images ) ), array( 'ad_id=?', $record['ad_id'] ) );
		unset( \IPS\Data\Cache::i()->advertisements );
	}

	/**
	 * Check if a file is valid
	 *
	 * @param	\IPS\Http\Url	$file		The file to check
	 * @return	bool
	 */
	public function isValidFile( $file )
	{
		try
		{
			foreach ( \IPS\Db::i()->select( '*', 'core_advertisements', array( 'ad_member<>0' ) ) as $ad )
			{
				if ( in_array( (string) $file, json_decode( $ad['ad_images'], TRUE ) ) )
				{
					return TRUE;
				}
			}
		}
		catch ( \UnderflowException $e ) { }
		
		return FALSE;
	}

	/**
	 * Delete all stored files
	 *
	 * @return	void
	 */
	public function delete()
	{
		foreach( \IPS\Db::i()->select( '*', 'core_advertisements', array( 'ad_member<>0' ) ) as $ad )
		{
			foreach ( json_decode( $ad['ad_images'], TRUE ) as $key => $location )
			{
				try
				{
					\IPS\File::get( 'nexus_Products', $location )->delete();
				}
				catch( \Exception $e ){}
			}
		}
	}
}